CNT             EQU     61H			
COLS            EQU     62H			
NEXTPTR         EQU 	63H			
SCANLINE        EQU	64H			
                ORG     00H	
                AJMP    RED
                ORG     0BH			
                AJMP    TIMER0
RED:            MOV     SP,#68H			
                ACALL   INIT
                SETB    TR0
                MOV     DPTR,#MSG		
                MOV	R0,#20H			
                MOV	R4,#0	
                MOV     R2,#32  	 	
S1:             MOV	A,R4
                MOVC    A,@A+DPTR
                MOV     @R0,A
                INC     R0
                INC     R4
                DJNZ    R2,S1
S2:             MOV	A,NEXTPTR
	        ADD	A,#32			
	        CJNE	A,#160,S3		
S3:             JC	S4
	        CLR     A
S4:	        MOV	NEXTPTR,A
 	        MOV 	R4,A
 	        MOV 	R0,#40H			
	        MOV 	R2,#32			
S5:        	MOV 	A,R4
                MOVC 	A,@A+DPTR
	        MOV 	@R0,A
                INC	     R0
	        INC 	R4
	        DJNZ	R2,S5
	        MOV 	R3,#16			
S6:	        ACALL	DELAY
	        ACALL	SHIFTL
	        DJNZ	R3,S6
	        SJMP	S2
;
INIT:           MOV     CNT,#4
                MOV     R1,#20H
	        MOV 	NEXTPTR,#0
                MOV     SCANLINE,#0
                MOV     COLS,#16
                CLR     P1.4            	
                CLR     P1.5            	
                MOV     TMOD,#2
                SETB    EA			
                SETB    ET0			
                MOV     TH0,#6			
                MOV     TL0,#6
                SETB    TR0
                RET
;
DELAY:          PUSH    A
                MOV     R5,#2
D1              MOV     R6,#250
D2:             MOV     R7,#200
                DJNZ    R7,$
                DJNZ    R6,D2
                DJNZ    R5,D1
                POP     A
                RET
;
SHIFTL:         PUSH    A			
                SETB    RS0
	        CLR 	TR0
                MOV     R0,#20H
                MOV     R1,#22H
                MOV     R2,#32
SL1:	        MOV     A,@R1
                MOV     @R0,A
                INC     R0
	        INC 	R0
                INC     R1
	        INC 	R1
                DJNZ    R2,SL1
                MOV     R0,#21H
                MOV     R1,#23H
                MOV     R2,#32
SL2:	        MOV     A,@R1
                MOV     @R0,A
                INC     R0
	        INC 	R0
                INC     R1
	        INC 	R1
                DJNZ    R2,SL2
	        SETB	TR0
                CLR     RS0
                POP     A
                RET
;
TIMER0:         PUSH    A
	        PUSH	PSW
	        CLR 	RS0
                CLR     TR0
                DJNZ    CNT,EXIT0
                MOV     CNT,#4
                MOV     A,@R1
                MOV     P2,A            		           
                SETB    P1.5            		
                CLR     P1.5
;*******************************************************
                MOV     P0,A				
                CLR     P1.7            		
                CLR     P1.7
;********************************************************
                INC     R1				
                MOV     A,@R1
                MOV     P2,A            		
                SETB    P1.4            		
                CLR     P1.4
;*********************************************************
                MOV     P0,A
                CLR     P1.6            		
                CLR     P1.6
;*********************************************************
                INC     R1
                MOV     A,SCANLINE
                MOV     P1,A
                INC     SCANLINE
                DJNZ    COLS,EXIT0
                MOV     COLS,#16
	        MOV 	R1,#20H
                MOV     SCANLINE,#0
EXIT0:          SETB    TR0
	        POP 	PSW
	        POP     A                        
                RETI               
;
MSG:    						
                DB      00H,00H,00H,00H	
	        DB  	00H,00H,00H,00H
	        DB      00H,00H,00H,00H		
	        DB   	00H,00H,00H,00H
	        DB  	00H,00H,00H,00H
	        DB  	00H,00H,00H,00H
	        DB  	00H,00H,00H,00H 
	        DB  	00H,00H,00H,00H
       
;
                DB      FFH,FFH,01H,C0H	
	        DB  	FFH,BFH,FFH,BFH
	        DB      FFH,BFH,FFH,BFH		
	        DB   	01H,C0H,FFH,FFH
	        DB  	FFH,FFH,01H,80H
	        DB  	FDH,FEH,FDH,FEH
	        DB  	FDH,FEH,FDH,FEH 
	        DB  	03H,FFH,FFH,FFH
;
	        DB  	FFH,FFH,7FH,FEH 
	        DB  	7FH,FEH,7FH,FEH 	
	        DB  	7FH,FEH,7FH,FEH	
	        DB  	7FH,FEH,FFH,FFH
	        DB  	FFH,FFH,C3H,87H
	        DB  	FDH,BBH,FDH,BDH
	        DB  	FDH,BEH,7DH,BFH
	        DB  	83H,BFH,FFH,FFH	 
;
	        DB      FFH,FFH,DDH,DFH
                DB      BBH,EFH,77H,F7H
                DB      FFH,BFH,01H,D8H
                DB      6DH,EBH,6DH,F3H
	        DB 	6DH,F3H,6DH,EBH
                DB      01H,D8H,FFH,BFH
                DB      07H,EEH,FFH,DFH
                DB      01H,80H,FFH,FFH
;
	        DB  	FFH,FFH,EFH,87H
	        DB  	6DH,B5H,63H,B5H
	        DB  	6FH,B5H,EFH,87H
	        DB  	FFH,FFH,EFH,DDH
	        DB   	EFH,C1H,EDH,DDH
	        DB  	01H,FFH,EFH,FCH
	        DB  	EDH,F3H,EBH,CFH
	        DB  	EFH,BFH,FFH,FFH
                END
