EN      	REG     P3.5
RW      	REG     P3.6
RS      	EG      P3.7
LCD	   	REG	P1
;=========================================================
		ORG	0	
INITIALIZE:
		MOV	A, #00111000B	
		CALL	WR_INST	;
		MOV	A, #00001000B	
		CALL	WR_INST	;
		MOV	A, #00000001B	
		CALL	WR_INST	;
		MOV	A, #00001111B	
		CALL	WR_INST	;
		MOV	A, #00000110B	
		CALL	WR_INST	;
;=========================================================
LOOP:		MOV	A, #10000000B	
	    	CALL	WR_INST	;
	    	MOV	DPTR, #LINE1	
	     	MOV	R0, #16
	    	CALL	WR_STRING	     
	     	CALL	DELAY2	     
;=========================================================
		MOV	A, #11000000B	
		CALL	WR_INST	;
		MOV	DPTR, #LINE2	
		MOV	R0, #16
		CALL	WR_STRING  	
		CALL	DELAY2	     
		JMP	LOOP      	
;=========================================================
WR_INST:  
        	CALL   CHECK_BF
        	CLR     RS
        	CLR     RW
        	SETB    EN
        	MOV     LCD,A
        	CLR     EN
       	 	RET
;=========================================================
CHECK_BF:  
        	PUSH    A
BUSY:   
        	CLR     RS
        	SETB    RW
        	SETB    EN
        	MOV     A,LCD
        	CLR     EN
        	JB      ACC.7,BUSY
        	CALL    DELAY
        	POP     A
        	RET
;=========================================================
WR_STRING:  
        	MOV     R1,#0
NEXT:   
        	MOV     A,R1
        	MOVC    A,@A+DPTR
        	CALL    WR_DATA
        	INC     R1
        	DJNZ    R0,NEXT
        	RET
;=========================================================
WR_DATA: 	CALL    CHECK_BF
        	SETB    RS
        	CLR     RW
        	SETB    EN
        	MOV     LCD,A
        	CLR     EN
        	RET
;=========================================================
DELAY:  	MOV     R6,#15
D1:     	MOV     R7,#200
        	DJNZ    R7,$
        	DJNZ    R6,D1
        	RET
;=========================================================
DELAY2: 	MOV	R5, #2 
D3:	   	MOV     R6,#200
D2:     	MOV     R7,#250
        	DJNZ    R7,$
        	DJNZ    R6,D2
	   	DJNZ	R5,D3
        	RET
;=========================================================
LINE1:		DB 'uP-2 LCM '
LINE2:		DB ' Testing'
;=========================================================
        END


