
BASE	        	EQU	-62500			
SPEAKER	  	     	REG	P1.0			
;=======================================================
	            	ORG	0         		
	            	JMP	INITIAL    		
	            	ORG	BH        		
	            	JMP	TONE_INT   		
	            	ORG	1BH       		
	            	JMP	BEAT_INT	     	
INITIAL:
	            	MOV	TMOD,#11H 		
	            	MOV	IE,#10001010B		
	            	MOV	SP,#70H    		
START:	       		CLR	F0        		
	            	MOV	R7,#0     		
	            	MOV	R6,#0     		
LOOP:	       		CALL	LOAD_TONE	     	
	            	CALL	LOAD_BEAT 		
	            	JNB	F0,$      	
	            	CLR	F0        		
	            	JMP	LOOP      		
;=======J=======================================
LOAD_TONE:
	            	MOV	DPTR,#TONE  		
	            	MOV	A,R7      		
	            	MOVC	A,@A+DPTR  		
	            	JNZ	CONTINUE  		
	            	MOV	R6,#0     		
	            	MOV	R7,#0     		
	            	JMP	LOAD_TONE 	
CONTINUE:
	            	MOV	20H,A     		
	            	MOV	TH0,A     		
	            	INC	R7        		
	            	MOV	A,R7      		
	            	MOVC	A,@A+DPTR 		
	            	MOV	21H,A     		
	            	MOV	TL0,A     		
	            	INC	R7        		
	            	SETB	TR0       		
	            	RET	          
;=======J`====================================
LOAD_BEAT:
	            	MOV	DPTR,#BEAT		
	            	MOV	A,R6			
	            	MOVC	A,@A+DPTR		
	            	MOV	R5,A			
	            	MOV	TH1,#>BASE		
	            	MOV	TL1,#<BASE		
	            	SETB 	TR1             	
	            	RET	          		
;=======_Ƶ{========================================
TONE_INT:
	           	CLR 	TR0	        	
	           	CPL 	SPEAKER			
	           	MOV 	A,20H			
	           	MOV 	TH0,A			
	           	MOV 	A,21H			
	           	MOV 	TL0,A	
	           	SETB	TR0	        	
	           	RETI			
;=======`礤_Ƶ{======================================
BEAT_INT:
		        CLR  	TR1	   		
	          	DJNZ 	R5,AGAIN	 	
	          	CLR  	TR0  			
	          	SETB 	F0   			
	          	JMP   	EXIT1			
AGAIN:	     		MOV  	TH1, #>BASE		
	          	MOV  	TL1, #<BASE		
	          	SETB 	TR1  			
EXIT1:	     		RETI			
;=================================================
TONE:
;=============Ĥ@p`==================================
 DB	252, 68,  252, 68	;DoBDo
 DB	252, 173,  252, 68	;ReBDo
;=============ĤGp`==================================
 DB	253, 52,  253, 10	;FaBMi
;=============ĤTp`==================================
 DB	252, 68,  252, 68	;DoBDo
 DB	252, 173,  252, 68	;ReBDo
;=============ĥ|p`==================================
 DB	253, 131,  253, 52	;SoBFa
;=======================================================
;=============Ĥp`==================================
 DB	252, 68,  252, 68	;DoBDo
 DB	254, 34,  253, 200	;Do^BLa
;=============Ĥp`==================================
 DB	253, 52,  253, 10	;FaBMi
 DB	254, 87	;Re^
;=============ĤCp`==================================
 DB	254, 6,  254, 6	;SiB Si
 DB	253, 200,  253, 52	;LaBFa
;=============ĤKp`==================================
 DB	253, 131,  253, 52, 0	;SoBFa
;=======================================================
;===========`======================================
BEAT:
;=============Ĥ@p`==================================
 DB	4, 4,  8, 8
;=============ĤGp`==================================
 DB	8, 16
;=============ĤTp`==================================
 DB	4, 4,  8, 8
;=============ĥ|p`==================================
 DB	8, 16
;=======================================================
;=============Ĥp`==================================
 DB	4, 4,  8, 8
;=============Ĥp`==================================
 DB	8, 8, 8
;=============ĤCp`==================================
 DB	4, 4,  8, 8
;=============ĤKp`==================================
 DB	8, 16   ,0
;=======================================================
	END
